/*
        error.h
        Mar. 21st, 2006
        Joris Roos <jorisr@gmx.de>
        Macros to take care of errors
*/

#ifndef ERROR_H

#define ERROR_H

#define FAILED           0
#define DONE             1

#define ERR_DIE          2
#define ERR_RESUME       3

/* macro to output and handle an occured error */
#define ERROR(typ, msg, args...) \
({ char _err[BUFSIZE]; \
   sprintf(_err, msg, ## args); \
   printf("error: %s\n", _err); \
   switch (typ) { \
        case ERR_DIE: prog_die(); break; \
        default: break; \
   } typ; })
   
/* to terminate program after serious error */
extern void prog_die(); 

#endif
